package com.engine.hrmelog.mapper;


import com.engine.hrmelog.entity.dto.LoggerContext;
import com.engine.hrmelog.entity.dto.LoggerDetailContext;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @ClassName: LocalElogAopDaoMapper
 * @Description 本地操作日志持久层
 * @Author tanghj
 * @Date 2021/2/24 9:35
 */
public interface LocalElogAopDaoMapper {

    int insertElogContext(@Param(value="logContent") LoggerContext loggerContext,
                       @Param(value="cusColumns")String cusColumns ,
                       @Param(value="cusValus")String cusValus,
                       @Param(value="tableName")String tableName);



    int insertElogDetail(@Param(value="detailContext") com.engine.hrmelog.entity.dto.LoggerDetailContext loggerDetailContext,
                         @Param(value="mainid")String mainid,
                         @Param(value="cusColumns")String cusColumns ,
                         @Param(value="cusValus")String cusValus,
                         @Param(value="detailTableName")String tableName);


    Integer queryElogContextById(@Param(value="id")Long id,
                                 @Param(value="tableName")String tableName);

    void batchInsertDetail(@Param("sql") String sql);

    void insertElogDetailPrepared(@Param("tablename") String detailTableName, @Param("list") List<com.engine.hrmelog.entity.dto.LoggerDetailContext> detailContexts, @Param("mainid") String mainid);

    void insertElogDetailPreparedHasCustonInfo(@Param("tablename") String detailTableName, @Param("list") List<LoggerDetailContext> detailContexts, @Param("mainid") String mainid, @Param(value="cusColumns")String cusColumns);

    void rollBackElogById(@Param("id") Long id,@Param("tableName") String tableName);

    void rollBackDetailElogByUUID(@Param("mainid") String uuid,@Param("tableName") String detailTableName);

}
